<script setup lang="ts">
import type { Recordable } from '@vben/types';

import { ref } from 'vue';

import { Page, useVbenModal, type VbenFormProps } from '@vben/common-ui';
import { getVxePopupContainer } from '@vben/utils';

import { Modal, Popconfirm, Space } from 'ant-design-vue';
import dayjs from 'dayjs';

import {   
  useVbenVxeGrid,
  vxeCheckboxChecked,
  type VxeGridProps 
} from '#/adapter/vxe-table';

import {
  villageExport,
  villageList,
  villageRemove,
} from '#/api/biz/village';
import type { VillageForm } from '#/api/biz/village/model';
import { commonDownloadExcel } from '#/utils/file/download';

import salaryImportModal from './salary-import-modal.vue';
import villageModal from './village-modal.vue';
import { columns, querySchema } from './data';

/**
 * 导入
 */
const [SalaryImpotModal, salaryImportModalApi] = useVbenModal({
  connectedComponent: salaryImportModal,
});

function handleImport() {
  salaryImportModalApi.open();
}

const formOptions: VbenFormProps = {
  commonConfig: {
    labelWidth: 80,
    componentProps: {
      allowClear: true,
    },
  },
  schema: querySchema(),
  wrapperClass: 'grid-cols-1 md:grid-cols-2 lg:grid-cols-3 xl:grid-cols-4',
};

const gridOptions: VxeGridProps = {
  checkboxConfig: {
    // 高亮
    highlight: true,
    // 翻页时保留选中状态
    reserve: true,
    // 点击行选中
    // trigger: 'row',
  },
  // 需要使用i18n注意这里要改成getter形式 否则切换语言不会刷新
  // columns: columns(),
  columns,
  height: 'auto',
  keepSource: true,
  pagerConfig: {},
  proxyConfig: {
    ajax: {
      query: async ({ page }, formValues = {}) => {
        return await villageList({
          pageNum: page.currentPage,
          pageSize: page.pageSize,
          ...formValues,
        });
      },
    },
  },
  rowConfig: {
    keyField: 'id',
  },
  // 表格全局唯一表示 保存列配置需要用到
  id: 'biz-village-index'
};

const [BasicTable, tableApi] = useVbenVxeGrid({
  formOptions,
  gridOptions,
});

const [VillageModal, modalApi] = useVbenModal({
  connectedComponent: villageModal,
});

function handleAdd() {
  modalApi.setData({});
  modalApi.open();
}

async function handleEdit(row: Required<VillageForm>) {
  modalApi.setData({ id: row.id });
  modalApi.open();
}

async function handleDelete(row: Required<VillageForm>) {
  Modal.confirm({
    title: '提示',
    content: '确认要删除当前数据项吗？',
    okText: '确定',
    cancelText: '取消',
    centered: true,
    async onOk() {
      await villageRemove(row.id);
      await tableApi.query();
    },
    onCancel() {},
  });
}

function handleMultiDelete() {
  const rows = tableApi.grid.getCheckboxRecords();
  const ids = rows.map((row: Required<VillageForm>) => row.id);
  Modal.confirm({
    title: '提示',
    okType: 'danger',
    content: `确认删除选中的${ids.length}条记录吗？`,
    onOk: async () => {
      await villageRemove(ids);
      await tableApi.query();
    },
  });
}

function handleDownloadExcel() {
  commonDownloadExcel(villageExport, '包村差旅补助数据', tableApi.formApi.form.values, {
    fieldMappingTime: formOptions.fieldMappingTime,
  });
}
</script>

<template>
  <Page :auto-content-height="true">
    <BasicTable table-title="包村差旅补助列表">
      <template #toolbar-tools>
        <Space>
          <a-button
            v-access:code="['biz:village:export']"
            @click="handleDownloadExcel"
          >
            {{ $t('pages.common.export') }}
          </a-button>
          <a-button
            v-access:code="['biz:salary:import']"
            @click="handleImport"
          >
            {{ $t('pages.common.import') }}
          </a-button>
          <a-button
            :disabled="!vxeCheckboxChecked(tableApi)"
            danger
            type="primary" 
            v-access:code="['biz:village:remove']" 
            @click="handleMultiDelete">
            {{ $t('pages.common.delete') }}
          </a-button>
          <!-- <a-button
            type="primary"
            v-access:code="['biz:village:add']"
            @click="handleAdd"
          >
            {{ $t('pages.common.add') }}
          </a-button> -->
        </Space>
      </template>
      <template #action="{ row }">
        <Space>
          <ghost-button
            v-access:code="['biz:village:edit']"
            @click.stop="handleEdit(row)"
          >
            {{ $t('pages.common.edit') }}
          </ghost-button>
          
          <ghost-button
              danger
              v-access:code="['biz:village:remove']"
              @click.stop="handleDelete(row)"
            >
              {{ $t('pages.common.delete') }}
            </ghost-button>
        </Space>
      </template>
    </BasicTable>
    <SalaryImpotModal @reload="tableApi.query()" />
    <VillageModal @reload="tableApi.query()" />
  </Page>
</template>
